#!/bin/sh
#
# PROVIDE: instiki
# REQUIRE: DAEMON
#
# Add the following line to /etc/rc.conf to enable instiki:
# instiki_enable (bool):      Set to "NO" by default
#                             Set it to "YES" to enable instiki
# instiki_flags (str):        Set to "--port 2500 --storage /usr/local/instiki/storage --daemon" by default.
#                             Extra flags passed to start command
#
. /etc/rc.subr

name="instiki"
rcvar=`set_rcvar`

command="/usr/local/instiki/instiki"
command_interpreter="/usr/local/bin/ruby18"

[ -z "$instiki_enable" ]	&& instiki_enable="NO"
[ -z "$instiki_flags" ]	&& instiki_flags="--port 2500 --storage /usr/local/instiki/storage --daemon"

load_rc_config $name

sig_stop=-TERM

run_rc_command "$1"

